<?php
/**
 * @file
 * Contains Configuration for miniOrange OTP Verification Module.
 */

require_once 'miniorange_otp_licensing_plan.inc';
/**
 * Showing Configuration form.
 */
function miniorange_otp_configuration($form, &$form_state) {
  global $base_url, $_miniorange_otp_msg;

  if (!MiniorangeOtpUtilities::isCustomerRegistered()) {

      $register_url = $base_url . '/admin/config/people/miniorange_otp/';
      $form['header'] = array(
      '#markup' => '<center><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
    );
    return $form;
  }
    miniorange_otp_handle_mo_check_ln($_miniorange_otp_msg);
    $smstemp = 'https://login.xecurify.com/moas/login?redirectUrl=' . MiniorangeOtpConstants::$baseUrl . '/moas/admin/customer/showsmstemplate';
    $smsconfig = 'https://login.xecurify.com/moas/login?redirectUrl=' . MiniorangeOtpConstants::$baseUrl . '/moas/admin/customer/smsconfig';
    $emailtemp = 'https://login.xecurify.com/moas/login?redirectUrl=' . MiniorangeOtpConstants::$baseUrl . '/moas/admin/customer/emailtemplateconfiguration';
    $emailconfig = 'https://login.xecurify.com/moas/login?redirectUrl=' . MiniorangeOtpConstants::$baseUrl . '/moas/admin/customer/configureSMTP';
    $var = variable_get('mo_customer_check_ln');

    $pcode = MiniorangeOtpcustomer::$pcode;
    $bcode = MiniorangeOtpcustomer::$bcode;

    $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',
    );

    $form['header_top_style_2'] = array('#markup' => '<div class="mo_saml_table_layout container">');

    $form['markup_1'] = array(
        '#markup' => '<h2>SMS & EMAIL CONFIGURATION</h2><hr><hr><br/>',
    );

    $form['markup_headLine'] = array(
        '#markup' => '<div class="mo_saml_highlight_background_note"><b>Look at the sections below to customize the Email and SMS that you receive:</b></div><br>'
    );

    $form['markup_2'] = array(
        '#markup' => '1. &nbsp <a href="#sms">Custom SMS Template</a> : Change the text of the message that you receive on your phones.<br>'
        . '2. &nbsp <a href="#sms">Custom SMS Gateway</a> : You can configure settings to use your own SMS gateway.<br>'
        . '3. &nbsp <a href="#email">Custom Email Template</a> : Change the text of the email that you receive.<br>'
        . '4. &nbsp <a href="#email">Custom Email Gateway</a> : You can configure settings to use your own Email gateway.<br><br>',
    );

    $form['markup_3'] = array(
        '#markup' => '<div class="mo_saml_highlight_background_note"><b> How can I change the SenderID/Number of the SMS I receive?</b></div>'
        . '<div id="q1" class="" ><ol><li>SenderID/Number is gateway specific. You will need to use your own SMS gateway for this.</li></ol></div><br>',
    );

    $form['markup_4'] = array(
        '#markup' => '<div class="mo_saml_highlight_background_note"><b>How can I change the Sender Email of the Email I receive?</b><br></div>'
        . '<div id="q2" class="" ><ol><li>Sender Email is gateway specific. You will need to use your own Email gateway for this.</li></ol></div><br>',
    );

    $url = $base_url . '/admin/config/people/miniorange_otp/licensing_plan';
    $desable_feature = "";
    $premium_feature = "";
    if($var != $pcode && $var != $bcode) {
        $desable_feature = 'disabled = "true"';
        $premium_feature = '[Premium Feature]';
    }

    $form['markup_5'] = array(
        '#markup' => '<h2>SMS CONFIGURATION <a href="'.$url.'" >'.$premium_feature.'</a></h2><hr><hr>',
    );
    $image1_options = array(
        'path' => $base_url . '/' . drupal_get_path('module', 'miniorange_otp') . '/includes/images/smsTemplate.jpg',
        'alt' => 'Custom SMS Template',
    );
    $image1 = theme('image', $image1_options);
    $form['image1']['image'] = array(
        '#markup' => 'Custom SMS Template <br>' . $image1 . '<br>'
            . '<a class="btn btn-primary btn-large" target="_blank" style="padding:5px;" '.$desable_feature.'  href="' . $smstemp . '">Change SMS Template</a></h4><br><hr>',
    );

    $image2_options = array(
        'path' => $base_url . '/' . drupal_get_path('module', 'miniorange_otp') . '/includes/images/smsGateway.jpg',
        'alt' => 'Custom SMS Gateway',
    );
    $image2 = theme('image', $image2_options);
    $form['image2']['image'] = array(
        '#markup' => 'Custom SMS Gateway <br>' . $image2 . '<br>'
            . '<a class="btn btn-primary btn-large" target="_blank" style="padding:5px;" '.$desable_feature.' href="' . $smsconfig . '">Change SMS Gateway</a></h4><br>',
    );

    $form['markup_8'] = array(
        '#markup' => '<h2>Email CONFIGURATION <a href="'.$url.'" >'.$premium_feature.'</a></h2><hr><hr>',
    );

    $image3_options = array(
        'path' => $base_url . '/' . drupal_get_path('module', 'miniorange_otp') . '/includes/images/emailTemplate.jpg',
        'alt' => 'Custom Email Template',
    );
    $image3 = theme('image', $image3_options);
    $form['image3']['image'] = array(
        '#markup' => 'Custom Email Template <br>' . $image3 . '<br>'
            . '<a class="btn btn-primary btn-large" target="_blank" style="padding:5px;" '.$desable_feature.' href="' . $emailtemp . '">Change Email Template</a></h4><br><hr>',
    );

    $image4_options = array(
        'path' => $base_url . '/' . drupal_get_path('module', 'miniorange_otp') . '/includes/images/emailGateway.jpg',
        'alt' => 'Custom Email Gateway',
    );
    $image4 = theme('image', $image4_options);
    $form['image4']['image'] = array(
        '#markup' => 'Custom Email Gateway <br>' . $image4 . '<br>'
            . '<a class="btn btn-primary btn-large" target="_blank" style="padding:5px;" '.$desable_feature.' href="' . $emailconfig . '">Change Email Gateway</a></h4><br><hr>',
    );

    $form['markup_idp_attr_header_top_div_close'] = array('#markup' => '</div>',
    );

    $form['markup_idp_attr_header_top_support'] = array('#markup' => '<div class="mo_saml_table_layout_support_1">',
    );

    $form['markup_support_1'] = array(
        '#markup' => '<h3><b>Support:</b></h3></span></h3><div>Need any help? Just send us a query so we can help you.<br /></div>',
    );

    $form['miniorange_otp_email_address'] = array(
        '#type' => 'textfield',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your Email'),
        '#required' => TRUE,
    );

    $form['miniorange_otp_phone_number'] = array(
        '#type' => 'textfield',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number with country code (+1)'),
        '#required' => TRUE,
    );

    $form['miniorange_otp_support_query'] = array(
        '#type' => 'textarea',
        '#cols' => '10',
        '#rows' => '5',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here.'),
        '#required' => TRUE,
    );

    $form['miniorange_otp_support_submit'] = array(
        '#type' => 'submit',
        '#value' => t('Submit Query'),
        '#submit' => array('miniorange_otp_send_query'),
    );

    return $form;
}

/**
 * Send support query.
 */
function miniorange_otp_send_query($form, &$form_state) {
    $email = $form['miniorange_otp_email_address']['#value'];
    $phone = $form['miniorange_otp_phone_number']['#value'];
    $query = $form['miniorange_otp_support_query']['#value'];
    $support = new MiniOrangeOtpSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if ($support_response) {
        drupal_set_message(t('Support query successfully sent'));
    } else {
        drupal_set_message(t('Error sending support query'), 'error');
    }
}