<?php
/**
 * @file
 * Contains Settings for miniOrange OTP Verification Module.
 */

 /**
  * Showing Settings form.
  */
function miniorange_otp_settings_information($form, &$form_state) {
    global $base_url;
  drupal_add_js(drupal_get_path('module', 'miniorange_otp') . '/js/toggle.js', 'file');
  if (!MiniorangeOtpUtilities::isCustomerRegistered()) {
      $register_url = $base_url . '/admin/config/people/miniorange_otp/';
      $form['header'] = array(
          '#markup' => '<center><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
      );
    return $form;
  }

  global $base_url;
  $conf_url = $base_url . '/?q=admin/config/people/miniorange_otp/configuration';
  $config_url = $base_url . '/?q=admin/config/people/accounts';

    $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',
    );

    $form['header_top_style_2'] = array('#markup' => '<div class="mo_saml_table_layout container">');

  $form['miniorange_otp_customer_validation'] = array(
    '#method' => 'post',
    '#type' => 'hidden',
    '#id' => 'mo_otp_verification_settings',
    '#value' => 'mo_customer_validation_settings',
  );

  $form['markup_1'] = array(
    '#markup' => '<h2>OTP VERIFICATION SETTINGS</h3><hr><br>',
  );

  $form['markup_2'] = array(
    '#markup' => 'By following these easy steps you can verify your users email or phone number instantly:<br><br>1. &nbsp Select the Verification method.<br>'
    . '2. &nbsp To configure your SMS/Email messages/gateway check under <a href="' . $conf_url . '">Configuration Tab</a>.<br>'
    . '3. &nbsp Save your settings.<br>'
    . '4. &nbsp Deselect the option: <b> "Require e-mail verification when a visitor creates an account" </b> under <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>"Registration and cancellation"</b> section from'
    . '<a href = "' . $config_url . '"> here</a>. This will allow new user to set their own <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;passwords while registration.<br>'
    . '5. &nbsp Log out and go to your registration or landing page for testing.<br><br>',
  );

  $form['miniorange_otp_options'] = array(
    '#type' => 'radios',
    '#tree' => TRUE,
    '#default_value' => variable_get('miniorange_otp_options', FALSE),
    '#title' => t('Drupal Default Registration Form'),
    '#options' => array(0 => t('Enable Email Verification'), 1 => t('Enable Phone Verification')),
  );

  $form['miniorange_otp_settings_save_button'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('miniorange_otp_settings_save'),
  );

    $form['markup_idp_attr_header_top_div_close'] = array('#markup' => '</div>',
    );

    $form['markup_idp_attr_header_top_support'] = array('#markup' => '<div class="mo_saml_table_layout_support_1">',
    );

    $form['markup_support_1'] = array(
        '#markup' => '<h3><b>Support:</b></h3></span></h3><div>Need any help? Just send us a query so we can help you.<br /></div>',
    );

    $form['miniorange_otp_email_address'] = array(
        '#type' => 'textfield',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your Email'),
    );

    $form['miniorange_otp_phone_number'] = array(
        '#type' => 'textfield',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number with country code (+1)'),
    );

    $form['miniorange_otp_support_query'] = array(
        '#type' => 'textarea',
        '#cols' => '10',
        '#rows' => '5',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here.'),
    );

    $form['miniorange_otp_support_submit'] = array(
        '#type' => 'submit',
        '#value' => t('Submit Query'),
        '#submit' => array('miniorange_otp_send_query'),
    );

    $form['miniorange_saml_support_note'] = array(
        '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@xecurify.com">info@xecurify.com</a></div></div></div>'
    );

  return $form;
}


/**
 * Handling Save Settings tab.
 */
function miniorange_otp_settings_save($form, &$form_state) {

  global $base_url;
  $user_enabled = $form_state['values']['miniorange_otp_options'];
  
  $logout_url = $base_url . '/?q=user/logout';
  variable_set('miniorange_otp_options', $user_enabled);
  $message = 'Settings saved successfully. You can go to your registration form page to test the plugin. <a href="' . $logout_url . '">Click here</a> to logout.';
  drupal_set_message(t($message));
}

/**
 * Send support query.
 */
function miniorange_otp_send_query($form, &$form_state) {
    $email = $form['miniorange_otp_email_address']['#value'];
    $phone = $form['miniorange_otp_phone_number']['#value'];
    $query = $form['miniorange_otp_support_query']['#value'];
    $support = new MiniOrangeOtpSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if ($support_response) {
        drupal_set_message(t('Support query successfully sent'));
    } else {
        drupal_set_message(t('Error sending support query'), 'error');
    }
}
